POST and PUT should use RABL templates for the response.
Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1216236

Description of problem:

The API returns significantly different information for the following two calls:

POST /api/v2/locations

GET /api/v2/locations/:id

This is problematic for two reasons:

This is inconsistent with how other paths behave, which makes writing client code harder to do.

Getting authoritative information about a just-created location requires a follow-up API call, which is time-consuming.

Version-Release number of selected component (if applicable):

Tested against Satellite-6.1.0-RHEL-6-20150424.0 and Satellite-6.1.0-RHEL-7-20150424.0.

How reproducible:

100%

Steps to Reproduce:

Here's a sample script:

>>> from nailgun import entities

    >>> loc_attrs = entities.Location().create_json()

    >>> loc_attrs2 = entities.Location(id=loc_attrs['id']).read_json()

    >>> loc_attrs.keys()  # contents of response to POST call

    [

        u'ancestry',

        u'apply_info_task_id',

        u'created_at',

        u'default_info',

        u'description',

        u'id',

        u'ignore_types',

        u'katello_default',

        u'label',

        u'name',

        u'title',

        u'updated_at',

    ]

    >>> loc_attrs2.keys()  # contents of response to GET call

    [

        u'compute_resources',

        u'config_templates',

        u'created_at',

        u'description',
        u'domains',

        u'environments',

        u'hostgroups',

        u'id',

        u'media',

        u'name',

        u'organizations',

        u'parameters',

        u'select_all_types',

        u'smart_proxies',

        u'subnets',

        u'title',

        u'updated_at',

        u'users',

    ]

 Actual results:

The actual results are as shown in the above example.

Expected results:

Both POST and GET requests should return the same information.

Additional info:

Related issues:

Related to Foreman - Bug #6882: POST create responses should be 201 Closed 08/01/2014

Related to Katello - Bug #11156: Org create API returns different wrapping an... Resolved 07/20/2015

Has duplicate Foreman - Bug #11015: PUT /api/v2/architectures/:id returns an ... Duplicate 07/05/2015

Has duplicate Foreman - Bug #11021: PUT /api/v2/config_templates/:id returns ... Duplicate 07/06/2015

Associated revisions

Revision d575926a - 07/13/2015 07:36 AM - Alon Goldboim

Fixes #10356 - changed the POST/PUT RABL template to be the same as the GET template

HTTP response code standardized to 201 on create.

Revision 4956aa79 - 10/13/2015 07:54 AM - Dominic Cleal 

refs #10356 - document 201 API response code

History

#1 - 05/04/2015 09:39 AM - Bryan Kearney

- Subject changed from POST /api/v2/locations returns an incomplete set of attributes to POST and PUT should use RABL templates for the response.

This was a known issue that the response of POST/PUT is just the object and it doesn't use a RABL template (render :json => @object), whereas the

GET :id included all the relationships which are in the RABL template show.json.rabl

#2 - 05/05/2015 03:51 AM - Dominic Cleal

- Category set to API

#3 - 07/06/2015 03:06 AM - Dominic Cleal

- Has duplicate Bug #11015: PUT /api/v2/architectures/:id returns an incomplete set of attributes added

#4 - 07/06/2015 04:32 AM - Dominic Cleal

- Has duplicate Bug #11021: PUT /api/v2/config_templates/:id returns an incomplete set of attributes added

#5 - 07/06/2015 05:24 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2519 added

- Pull request deleted ()

#6 - 07/09/2015 06:17 AM - Alon Goldboim
- Related to Bug #6882: POST create responses should be 201 added

#7 - 07/13/2015 07:37 AM - Dominic Cleal

- Assignee set to Alon Goldboim

- translation missing: en.field_release set to 63

#8 - 07/13/2015 08:01 AM - Alon Goldboim

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset d575926a689fd6abd6f26ee2823ce95eef07dd38.

#9 - 07/20/2015 09:54 AM - Dominic Cleal

- Related to Bug #11156: Org create API returns different wrapping and attributes added
